/*
One of those Weeks Episode 43: The Secret Project
Copyright (c) 2008,2011-2012 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep43
{
	// Adobe Imports
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.Event;
	import flash.events.MouseEvent;

	// Blazing Games Imports
	import com.blazinggames.ootw.converse.*;

	public class OotW43Conversation
//	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

// ***** VARIABLES **********************************************************

		protected var _speach_movie:ISpeach;
		protected var _scriptHandler:DefaultScriptCommand;
		protected var _conversation:ConversationHandler;
		protected var _owner:OotW43;

// ***** CONSTRUCTOR ********************************************************

		public function OotW43Conversation(speach_movie:ISpeach)
		{
			_speach_movie = speach_movie;
			_scriptHandler = new DefaultScriptCommand();
			_conversation = new ConversationHandler(_speach_movie, _scriptHandler);
			_speach_movie.clearDisplay();
			_conversation.addEventListener(Converse.TOPIC_EVENT, topicHandler);
			
			// create the conversation tree.
			var fs:String = "ISFLAGSET TRUE";
			_conversation.addTopic( ConversationHandler.EXIT_TOPIC);
			_conversation.addTopic( new ConversationTopic(
					"ShowPortal", "Continue", "This should be taking you to the end sequence.", 
					3,0, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					"OVER", "To be continued...", "This should be taking you to the end sequence.", 
					3,0, fs, null, new Array("Exit")));

			// intro conversation
			_conversation.addTopic( new ConversationTopic(
					"StartEp", "Start game", "As you have already been told, this research station has been deemed very dangerous. The main reason for that is in fact my secret project. Take a look through the window to to get a glimpse of this project.", 
					3,1, fs, null, new Array("ShowPortal")));

			// main conversation
			_conversation.addTopic( new ConversationTopic(
					"StartMain", "Start game", "As you can see, I have developed an inter-dimensional portal. There are still issues with it, and I want to focus on my Gorbon Defense project. Still, if you were to go through that portal, you would end up on the planet you see through the portal. Of course, to do that you would have to get by the security on the door to do that.", 
					3,1, fs, null, new Array("Yourself", "Project","Door","Gorbon","Done")));
			_conversation.addTopic( new ConversationTopic(
					"Main", "I think that covers this subject", "Do you have any questions before I take my lunch break and LEAVE THE FOUR OF YOU ALONE  to clean this lab?", 
					3,1, fs, null, new Array("Yourself", "Project","Door","Gorbon","Done")));

			// Yourself conversation
			_conversation.addTopic( new ConversationTopic(
					"Yourself", "Tell me about yourself", "I am flattered that you are interested in me. I will assume that it is a real interest and not what your species refers to as Brown-nosing. What would you like to know.", 
					3,1, fs, null, new Array("FavoriteColor","FavoriteNumber","FavoriteLetter","WhyScientist","Main")));
			_conversation.addTopic( new ConversationTopic(
					"FavoriteColor", "What is your favorite color?", "My favorite color. The color right at the edge of the human visible spectrum before the spectrum becomes \"ultra\".", 
					3,1, fs, new Array("SETFLAG COLOR"), new Array("FavoriteNumber","FavoriteLetter","WhyScientist","Main")));
			_conversation.addTopic( new ConversationTopic(
					"FavoriteNumber", "What is your favorite number?", "The loneliest number when it is beside itself is my favorite number.", 
					3,1, fs, new Array("SETFLAG NUMBER"), new Array("FavoriteColor","FavoriteLetter","WhyScientist","Main")));
			_conversation.addTopic( new ConversationTopic(
					"FavoriteLetter", "What is your favorite letter?", "My favorite letter is a significant letter to programmers. In fact, many of your programming languages are modeled after it. This language became object oriented when ++ was added to it's name.", 
					3,1, fs, new Array("SETFLAG LETTER"), new Array("FavoriteColor","FavoriteNumber","WhyScientist","Main")));
			_conversation.addTopic( new ConversationTopic(
					"WhyScientist", "Why did you become a scientist?", "When you get right down to it, science is about learning how the universe works. We have to spend our lives in this universe, so why not devote ones life to understanding it. As for multi-dimensional physics, well I was good at math so that was the science that best fit my skill set.", 
					3,1, fs, null, new Array("FavoriteColor","FavoriteNumber","FavoriteLetter","Main")));

			// Project conversation
			_conversation.addTopic( new ConversationTopic(
					"Project", "Tell me about the portal", "The project is a portal that allows the person who enters it to instantly travel to another part of the universe. Initially it was a military project but they are losing interest in it. Once we can get the bugs out of it, it is possible that it will be used for public transit.", 
					3,1, fs, null, new Array("PortalWork","PortalSafe","PortalMilitary","Main")));
			_conversation.addTopic( new ConversationTopic(
					"PortalWork", "How does it work?", "The portal actually takes you outside of our universe by bouncing you off of a parallel universe. When you re-enter the universe, it is at the location the portal was set to, but you can only go to a location in the universe where you have actually been so that you have entangled strings.", 
					3,1, fs, null, new Array("PortalEntanglement","PortalSafe","PortalMilitary","Main")));
			_conversation.addTopic( new ConversationTopic(
					"PortalEntanglement", "Entangled strings?", "At the sub-atomic level the universe is made up of vibrating strings. When you move through the universe, the strings get entangled. This entanglement is what lets you be pulled back into the universe.", 
					3,1, fs, new Array("SETFLAG ENTANGLEMENT"), new Array("PortalSafe","PortalMilitary","Main")));
			_conversation.addTopic( new ConversationTopic(
					"PortalSafe", "Is it safe?", "As long as the power flow to the portal is not interrupted during the transfer and all creatures passing through the portal have been to the destination. Sadly this space stations power is not as good as it should be so the portal only works 99.9% of the time.", 
					3,1, fs, null, new Array("PortalWork","PortalMilitary","Main")));
			_conversation.addTopic( new ConversationTopic(
					"PortalMilitary", "Why is the military losing interest?", "The requirement that all people using the portal must have been to the target location makes troop transfer problematic and rules out using the portal for invasions.", 
					3,1, fs, null, new Array("PortalWork","PortalSafe","Main")));

			// Door conversation
			_conversation.addTopic( new ConversationTopic(
					"Door", "Tell me about the door", "The door has three chemical codes. The chemical codes are made by combining different portions of pairs of chemicals. I remember the code by assigning a chemical to my favorite letter, number and color.", 
					3,1, fs, null, new Array("DoorCode1","DoorCode2","DoorCode3","DoorSecurity","Main")));
			_conversation.addTopic( new ConversationTopic(
					"DoorCode1", "Any hints about the first code?", "My number and my letter must be combined with the portions adding to two less than my favorite number. The portion of the letter is half that of the number.", 
					3,1, fs, new Array("SETFLAG COMBO1"), new Array("DoorCode2","DoorCode3","DoorSecurity","Main")));
			_conversation.addTopic( new ConversationTopic(
					"DoorCode2", "Any hints about the second code?", "My letter and my color. The letter has parts equal to its spot. The color is the floor of half the letter squared.", 
					3,1, fs, new Array("SETFLAG COMBO2"), new Array("DoorCode1","DoorCode3","DoorSecurity","Main")));
			_conversation.addTopic( new ConversationTopic(
					"DoorCode3", "Any hints about the third code?", "One part each of the missing of the first two.", 
					3,1, fs, new Array("SETFLAG COMBO3"), new Array("DoorCode1","DoorCode2","DoorSecurity","Main")));
			_conversation.addTopic( new ConversationTopic(
					"DoorSecurity", "Why all the security?", "Early tests of the portal had feedback problems, with the feedback being unnaturally hot. Those problems have been fixed, but the bureaucrats are overly nervous after losing the remote testing stations.", 
					3,1, fs, null, new Array("DoorCode1","DoorCode2","DoorCode3","Main")));

			// Gorbon conversation
			_conversation.addTopic( new ConversationTopic(
					"Gorbon", "Tell me about the Gorbons", "The Gorbons are a race of creatures who have replaced their bodies entirely with cybernetic parts. Unfortunately, they never took reproduction into account and their brains seem to be going into some type of dementia so they are trying to eliminate all non-Gorbon life.", 
					3,1, fs, null, new Array("AntiGorbon","GorbonBureaucrats","GorbonDanger","Main")));
			_conversation.addTopic( new ConversationTopic(
					"AntiGorbon", "How far along is your anti-Gorbon technology?", "It is functional but I am trying to simplify it to the point that technology-lacking species, such as you Humans, could replicate the technology and defend yourselves from the threat.", 
					3,1, fs, null, new Array("GorbonBureaucrats","GorbonDanger","Main")));
			_conversation.addTopic( new ConversationTopic(
					"GorbonBureaucrats", "What do you think the bureaucrats did?", "I heard rumors, hopfully false ones, that some of our \"leaders\" are trying to reach a non-aggression pact with the Gorbons by giving them Faster than Light technology. Their lack of technology is the biggest thing holding back the Gorbon threat and they will not honor any treaty!",
					3,1, fs, null, new Array("AntiGorbon","GorbonDanger","Main")));
			_conversation.addTopic( new ConversationTopic(
					"GorbonDanger", "How dangerous do you think they are?", "Thankfully their travel technology level is limited, though their weapons rival any of ours. They are clearly deranged and will go through with their war against the rest of the galaxy unless they can be stopped.", 
					3,1, fs, null, new Array("AntiGorbon","GorbonBureaucrats","Main")));


			// Done
			_conversation.addTopic( new ConversationTopic(
					"Done", "I think I know enough", "It's not as if I gave you enough info to open the door and use the portal to return home, though if you somehow did do that I would be happy for you. Well, I'm off to lunch.", 
					3,1, fs, null, new Array("OVER")));
		}

// *****

		function topicHandler(event:Event):void {
			var top:ConversationTopic = _conversation.getLastTopic();
			trace(top.topic + "topic was selected");

			if ((top.topic == "Exit") || (top.topic == "OVER")) {
				_owner.toScore();
			} else if (top.topic == "ShowPortal") {
				_owner.toPortal();
			} else {
				_conversation.showTopic(top.topic);
			}
		}

// ***** Functions - General control ****************************************

		public function showTopic(s:String, owner:OotW43)
		{
			_conversation.showTopic(s);
			_owner = owner;
		}
		
		public function resetConversation():void
		{
			_scriptHandler.parseCommand("CLEARFLAG COLOR");
			_scriptHandler.parseCommand("CLEARFLAG LETTER");
			_scriptHandler.parseCommand("CLEARFLAG NUMBER");
			_scriptHandler.parseCommand("CLEARFLAG COMBO1");
			_scriptHandler.parseCommand("CLEARFLAG COMBO2");
			_scriptHandler.parseCommand("CLEARFLAG COMBO3");
			_scriptHandler.parseCommand("CLEARFLAG ENTANGLEMENT");
		}
		
		public function scoreConversation():int
		{
			var score:int = 0;
			if (_scriptHandler.parseQuery("ISFLAGSET COLOR"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET LETTER"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET NUMBER"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET COMBO1"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET COMBO2"))
				++score;
			if (_scriptHandler.parseQuery("ISFLAGSET COMBO3"))
				++score;
			// And the special hard to reach sub-topic bonus
			if (_scriptHandler.parseQuery("ISFLAGSET ENTANGLEMENT"))
				++score;
				
			return score;
		}
	} // end class
} // end package

